#! /usr/bin/perl
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
print header;
print start_html(-title=>'CGI Calculate Cost Answer');

# if no form data got sent to this program, we should print
# a message, finish the web page and quit.
if( !param()) {
	print "there is NO stuff in the parameters";
	print end_html(),"\n";
	exit 1;
}

# first we retrieve the value of the 'brand' radio button element.
# All the radio buttons in the group have the same name and the value
# is the contents of the value attribute of the button
# that was selected.
# The $ in front of the variable name means we want to use it as a normal
# variable.
$brand=param("brand");

# now we do pretty much the same thing with the size group of
# radio buttons.
$size=param("size");

# the last thing to get is the value of the howmany text box.
$howmany=param("howmany");

# if we got here, then all the data values are filled in and correct.
# # now we will open a file that contains the costs.
# The format of this file is like this
# brand:size=cost
# For example,
# cola-12oz=0.65
# cola-20oz=1.00

# to open the file, we use the open function.
# This takes two arguments. The first is the filehandle.
# The filehandle is an internal name for the file.
# We will use it when reading from the file.
# The second argument is the name of the file along
# with a marker to indicate how the file should be read or written.
# Since opening a file can fail, we need to check for and handle that
# problem. These kind of things comes up often in Perl so we have a nice 
# way to handle it.
# We write the statement we want to check, in  this case open() and follow
# it with an OR symbol (||).
# After the || we use a function called die().
# The die function takes an argument as a string.
# It prints the string and exits the program.
# So, our file open looks like this

open(IN,"<version4.txt") || die("can't open file version4.txt");

# The leading '<' before the 'version4.txt', tells open that
# we are reading from the file. This comes from the UNIX mechanism for
# re-directing the output from programs.

# If we got here, the file is open for reading

# we are going to store the values from the file as a hash
# A hash is like an array, except that we can use strings as an index
# instead of numbers.
# This is what the param object is. When we give it a string like "brand"
# it gives us the value associated with that string.
# That is why these are also called associative arrays.
my %costs;

# This loop will read the file line by line until the
# end of the file is reached.
# By default, the line is put in the variable $_.

while(<IN>)
{
   chomp;   # strip the ending newline
   @nv = split(/=/);  # split on the =
   $costs{$nv[0]} = $nv[1];
} # while file not empty

# here is some diagnostic code to print the table
# of brands sizes and costs
#@names= keys %costs;
#foreach $k (@names) {
#	$val=$costs{$k};
#	print "$k --> $val\n";
#}

# The keys in the costs hash are the brand followed by a -
# followed by the size. So we will construct the key from
# the values we got from the form.
# The . (period) operator concatenates strings

$key = $brand . "-" . $size;

$cost = $costs{$key};

# now the total cost
$totalcost = $cost * $howmany;

# to make it prettier, lets figure out nice names for the brands and sizes
if ($brand eq "cola") { $brandout = "Cola Soda"; }
if ($brand eq "rbeer") { $brandout = "Root Beer Soda"; }
if ($brand eq "water") { $brandout = "Cold Water"; }
if ($brand eq "tea") { $brandout = "Ice Tea"; }

if ($size eq "12oz") { $sizeout = "12 Oz."; }
if ($size eq "20oz") { $sizeout = "20 Oz."; }
if ($size eq "1liter") { $sizeout = "1 liter"; }
if ($size eq "2liter") { $sizeout = "2 liter"; }

#print the charge information
print "<center>\n";
print "$howmany $sizeout containers of $brandout at \$$cost per unit cost \$$totalcost\n";
print "</center>\n";

# all done, print the closing body and html tags
print end_html(),"\n";
exit 1;
