import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * A test applet that shows GUI components
 *
 * @author Kent Archie
 * @version 3/6/2002
 */

// since its an applet, it extends JApplet
// This uses the listener technique of using the same class
// for the applet and the listener.
public class app2 extends JApplet implements ActionListener {

    private JLabel title;   // title at top of display
    private JLabel status;  // current value of the button counter
    private JButton click;  // the button to press
    private JPanel upper;   // holds the title and status
    private JPanel appPanel; // holds the whole display
    private int count=0;     // how many times has the button been pressed

	// by adding this method, we can run this applet by itself
	// without a web page
	public static void main(String[] args)
	{
		System.out.println("main started");
		app2 theapp = new app2();
		theapp.init();
		System.out.println("main ended");
	} // main

	// set up the display
    public void init() {
		System.out.println("init started");
        title = new JLabel ("Button Test", SwingConstants.CENTER);
        title.setFont (new Font ("Serif", Font.PLAIN, 12));

        click = new JButton("Press me");
        // set up the event handler for the button
		// this object is the applet and the listener
        click.addActionListener(this);
        
        status = new JLabel("",SwingConstants.CENTER); // nothing there to start

        upper = new JPanel();  // just the title and status lines
        upper.setLayout(new BorderLayout());
        upper.add(title,BorderLayout.NORTH);
        upper.add(status,BorderLayout.SOUTH);
    
        // the this holds the whole display
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add( upper,BorderLayout.NORTH);
        getContentPane().add( click, BorderLayout.SOUTH);
		System.out.println("init ended");
    } // init

	// this is the method from the listener interface
	public void actionPerformed (ActionEvent event)
	{
        Object source = event.getSource();  // who sent the action?
        if(source == click) {  // was our button the source
           count++;
           if(count <= 1)
              status.setText("The button was pressed once");
           else
              status.setText("The button was pressed " + count + " times");
        }
        else
           status.setText("Something else happened");
	} // actionPerformed

	// the next two methods are used when the appplet is run inside
	// the appletviewer applictaion. They are not needed to run the 
	// applet in a browser
    // used in appletviewer to show information
    public String getAppletInfo() {
        return "Title: Applet Demo\nAuthor: Kent Archie \nDisplays a text a few times .";
    } // getAppletInfo

	// this tells the applet controls what the parameters are
    public String[][] getParameterInfo() {
        String pinfo[][] = {
            {"text", "string", "Text to display"},
            {"times", "int", "How many times"},
        };
        return pinfo;
    } // getParameterInfo
} // app2
