#! /usr/bin/perl
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
print header;
print start_html(-title=>'CGI Calculate Cost Answer');

# if no form data got sent to this program, we should print
# a message, finish the web page and quit.
if( !param()) {
	print "there is NO stuff in the parameters";
	print end_html(),"\n";
	exit 1;
}

# first we retrieve the value of the 'brand' radio button element.
# All the radio buttons in the group have the same name and the value
# is the contents of the value attribute of the button
# that was selected.
# The $ in front of the variable name means we want to use it as a normal
# variable.
# We have to check if the form was submitted without
# selecting anything. It would be better to check this on the web page using
# JavaScript
$brand=param("brand");
if($brand eq "") {
	print "You have to select a brand of beverage first";
	print end_html(),"\n";
	exit 1;
}

# now we do pretty much the same thing with the size group of
# radio buttons.
$size=param("size");
if($size eq "") {
	print "You have to select a size of beverage first";
	print end_html(),"\n";
	exit 1;
}

# the last thing to check is the value of the howmany text box.
# We should check that is there, like the others but also that
# it contains a number.
# Also, we should check that the number is between 1 and 100
# One extension would be to have the max allowed value be checked
# against the current inventory.
$howmany=param("howmany");
if($howmany eq "") {
	print "You have to enter the quantity you want";
	print end_html(),"\n";
	exit 1;
}
# to check if the value is a number, we use regular expressions.
# The =~ operator means to search the variable for matches of the
# pattern between the /'s.
# The \D is a special pattern that matches and single character
# which is NOT a digit.
# The + after it means to repeat this 1 or more times.
# To this pattern matches "hello" since all the characters
# are NOT digits.
# It also matches "10g" because the g is not a digit.
# If the value is 10, it doesn't match since none of the
# characters are non-digits.
if($howmany =~ /\D+/) {
	print "You have to enter the quantity as a number";
	print end_html(),"\n";
	exit 1;
}
if(($howmany < 1) || ($howmany > 100)) {
	print "The quantity has to be between 1 and 100";
	print end_html(),"\n";
	exit 1;
}

# if we got here, then all the data values are filled in and correct.
# First we figure out the cost of a single item

if(($brand eq "cola") && ($size eq "12oz"))    { $cost = 0.65; }
if(($brand eq "cola") && ($size eq "20oz"))    { $cost = 1.00; }
if(($brand eq "cola") && ($size eq "1liter"))  { $cost = 2.00; }
if(($brand eq "cola") && ($size eq "2liter"))  { $cost = 3.00; }

if(($brand eq "rbeer") && ($size eq "12oz"))   { $cost = 0.65; }
if(($brand eq "rbeer") && ($size eq "20oz"))   { $cost = 1.00; }
if(($brand eq "rbeer") && ($size eq "1liter")) { $cost = 2.00; }
if(($brand eq "rbeer") && ($size eq "2liter")) { $cost = 2.00; }

if(($brand eq "water") && ($size eq "12oz"))   { $cost = 0.35; }
if(($brand eq "water") && ($size eq "20oz"))   { $cost = 0.70; }
if(($brand eq "water") && ($size eq "1liter")) { $cost = 1.00; }
if(($brand eq "water") && ($size eq "2liter")) { $cost = 1.50; }

if(($brand eq "tea") && ($size eq "12oz"))     { $cost = 1.00; }
if(($brand eq "tea") && ($size eq "20oz"))     { $cost = 1.50; }
if(($brand eq "tea") && ($size eq "1liter"))   { $cost = 3.00; }
if(($brand eq "tea") && ($size eq "2liter"))   { $cost = 5.00; }

# now the total cost
$totalcost = $cost * $howmany;

# to make it prettier, lets figure out nice names for the brands and sizes
if ($brand eq "cola") { $brandout = "Cola Soda"; }
if ($brand eq "rbeer") { $brandout = "Root Beer Soda"; }
if ($brand eq "water") { $brandout = "Cold Water"; }
if ($brand eq "tea") { $brandout = "Ice Tea"; }

if ($size eq "12oz") { $sizeout = "12 Oz."; }
if ($size eq "20oz") { $sizeout = "20 Oz."; }
if ($size eq "1liter") { $sizeout = "1 liter"; }
if ($size eq "2liter") { $sizeout = "2 liter"; }

#print the charge information
print "<center>\n";
print "$howmany $sizeout containers of $brandout cost $totalcost\n";
print "</center>\n";

# all done, print the closing body and html tags
print end_html(),"\n";
exit 1;
