function checkform()
{
  // we will need to acces the form object so
  // we will find it here. We also need the individual
  // for elements for testing.
   var sodaform = document.getElementById("soda");
   var brand = document.getElementById("brand");
   var size = document.getElementById("size");
   var howmany = document.getElementById("howmany");
   
   /* 
      To check radio buttons, we have to examine each button.
      The for object has an array for each radio button group
      that has the same name as the group name.
      Each entry in the array is a radio button object.
      The first radio button element in the form is in slot 0
      of this array and the second is in slot 1 and so on.
      The length property of an array is the number of slots
      in the array.
      In this case, the radio button group name is brand so that
      is the array name. brand.length is the number of slots in the
      array.
      Each radio button object has a checked property that is
      true if that button has been selected and false otherwise.
      We look at each button and increment a counter variable
      if the button is selected. If it is still 0 at the end of
      the loop, none of the buttons have been selected.
   */
   
   var brandcheck=0;
   for(i=0; i < sodaform.brand.length; i++) 
   {
      if(sodaform.brand[i].checked) brandcheck++;
   }
   if(brandcheck == 0) {
           alert("You must choose a brand");
           brand.focus();
           return false;
   }

   // here we do the same kind of check on the size radio buttons.
   var sizecheck=0;
   for(i=0; i < sodaform.size.length; i++) 
   {
      if(sodaform.size[i].checked) sizecheck++;
   }
   if(sizecheck == 0) {
           alert("You must choose a size");
           size.focus();
           return false;
   }

   // first check if the howmany text box is empty
   if(howmany.value == "") {
           alert("You must enter a number of items");
           howmany.focus();
           return false;
   }
   /* 
      To check if the user entered a number, we first have to
      convert the value property, which is a string, into a number.
      The parseInt() function (part of JavaScript) will do this.
      Then we convert that back to a string.
      If the two strings are the same, then all is well.

      An example of how this works is if you entered "10G" into
      the field.
      parseInt() will turn this in to 10.
      The toString() method will then convert the number 10
      into the string "10". When we compare this to the original
      value, "10G", they won't match.
      If you had entered "10" in the first place, parseInt() will give us 10
      back as a number.
      Converting that to a string gives "10" and this matches the original
      value.
      If you typed in "hello", parseInt() returns 0.
      Converted to "0" by toString(), this won't match the original.
   */
   var num = parseInt(howmany.value);
   var numstr = num.toString();
   if(howmany.value != numstr) {
           alert("The number of items value is not a number");
           howmany.value="";  // clear the box
           howmany.focus();
           return false;
   }

   // this function checks that the amount requested is available.
   // it will be written by the PHP program that includes this code.
   if(notavailable()) return false;

   return true;
} // checkform

/*
   Since we don't have a way to ask the brand or size object which
   of the buttons (if any) were selected, we have to check each one.
   The form object has a property which is an array 
   of the individual radio buttons, it is named with the group name.
   In this case, it is either brand or size.
   Each of those button objects has a checked property that is true
   if the user clicked on that button.
   So we will check each button to see if it was clicked on.
   If it was, its value property contains the name of the
   brand or size, so we will return that.
   The two functions are very similar so these comments will
   be used for both.
   Some of this code is used in the checkform() function
   to make sure the choices were made.
*/
function getbrand()
{
   var sform = document.getElementById("soda");
   for(i=0; i < sform.brand.length; i++) {  // for each radio button in the group
      if(sform.brand[i].checked) // was it clicked on?
         return sform.brand[i].value; // yes, return the value
   }
   // if we get here, nothing checked so return empty string
   return "";
} // getbrand

function getsize()
{
   var sform = document.getElementById("soda");
   for(i=0; i < sform.size.length; i++) {  // for each radio button in the group
      if(sform.size[i].checked) // was it clicked on?
         return sform.size[i].value; // yes, return the value
   }
   // if we get here, nothing checked so return empty string
   return "";
} // getsize
