/* Each of the source div tags is id'ed with 'a' followed by a number.
 There is a corresponding 'b' is with the same number.
 This finds all the 'a' objects, pulls out the HTML and passes that
 through striptags() and puts the result in the 'b' object.
 Usually the source and destination objects are in seperate
 columns of a table.
 Here is an example of typical use
 <table border>
      <tr>
         <td>
	 <div id="a0">
      This is before the first text box<br>
      <input type="text" name="box1">
	  </div>
   </td>
   <td>
	 <div id="b0"> </div>
   </td>
   </tr>
	</table>
*/

function doall()
{
	var i = 0;
	var t,f;
	while (f = MWJ_findObj("a" + i))
	{
   	t = MWJ_findObj("b" + i);
		t.innerHTML = "<tt>\n" + striptags(f.innerHTML)+ "</tt>\n";
		i++;
	} // while
} // doall

// convert most tagstart and tagend (< and >) chars to
// character entities (&lt; and &gt;)
// Skips br tags and removes spurious tbody tags inserted by browser
// adds br tags to control appearance
function striptags(s)
{
	var res=new String("");
	var str = s.toLowerCase();
	for(i=0; i < str.length; i++)
	{
		c = str.charAt(i);	
		switch(c)
		{
		case '<':
			// check for br tag
			if((str.charAt(i+1) == 'b') && (str.charAt(i+2) == 'r')) {
				i += 3;  // skip br tag	
			}
			else // remove tbody tag
				if((str.charAt(i+1) == 't') && (str.charAt(i+2) == 'b')) {
					i += 6;
				}
				else // remove /tbody tag
					if( (str.charAt(i+1) == '/') && 
					    (str.charAt(i+2) == 't') &&
					    (str.charAt(i+3) == 'b') ) {
						i += 7;  
					}
					else
						res += "&lt;";
			break;
		case '>':
			res += "&gt;<br>";
			break;
		default:
			res += c;
		} // esac
	} // for
//	alert("striptags:" + res + ":");
	return res;
} // striptags
